/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type GetSurfaceResponseMessagesItemStatus = "Created" | "Queued" | "Delivered" | "Aborted" | "Seen" | "Interacted";
declare const GetSurfaceResponseMessagesItemStatus: {
    readonly Created: "Created";
    readonly Queued: "Queued";
    readonly Delivered: "Delivered";
    readonly Aborted: "Aborted";
    readonly Seen: "Seen";
    readonly Interacted: "Interacted";
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface GetSurfaceResponseMessagesItem {
    uid: string;
    name: string;
    status: GetSurfaceResponseMessagesItemStatus;
    surface: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface GetSurfaceResponse {
    sid: string;
    uid: string;
    messages: GetSurfaceResponseMessagesItem[];
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
/**
 * @example
 *     {
 *         userIdentifier: "userIdentifier"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string"
 *     }
 */
interface GetSurfaceRequest {
    userIdentifier: string;
    groupIdentifier?: string;
}

type index$2_GetSurfaceRequest = GetSurfaceRequest;
type index$2_GetSurfaceResponse = GetSurfaceResponse;
type index$2_GetSurfaceResponseMessagesItem = GetSurfaceResponseMessagesItem;
declare const index$2_GetSurfaceResponseMessagesItemStatus: typeof GetSurfaceResponseMessagesItemStatus;
declare namespace index$2 {
  export {
    index$2_GetSurfaceRequest as GetSurfaceRequest,
    index$2_GetSurfaceResponse as GetSurfaceResponse,
    index$2_GetSurfaceResponseMessagesItem as GetSurfaceResponseMessagesItem,
    index$2_GetSurfaceResponseMessagesItemStatus as GetSurfaceResponseMessagesItemStatus,
  };
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
/**
 * @example
 *     {
 *         userIdentifier: "userIdentifier",
 *         engagement: "engagement"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         engagement: "engagement"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         engagement: "engagement"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         engagement: "engagement"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         engagement: "engagement"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         engagement: "engagement"
 *     }
 */
interface EngagementRequest {
    userIdentifier: string;
    groupIdentifier?: string;
    engagement: string;
    effect?: string;
}

type index$1_EngagementRequest = EngagementRequest;
declare namespace index$1 {
  export {
    index$1_EngagementRequest as EngagementRequest,
  };
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare class DoptApiError extends Error {
    readonly statusCode?: number;
    readonly body?: unknown;
    constructor({ message, statusCode, body }: {
        message?: string;
        statusCode?: number;
        body?: unknown;
    });
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare class DoptApiTimeoutError extends Error {
    constructor();
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class BadRequestError extends DoptApiError {
    constructor(body?: unknown);
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class UnauthorizedError extends DoptApiError {
    constructor(body?: unknown);
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class NotFoundError extends DoptApiError {
    constructor(body?: unknown);
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class InternalServerError extends DoptApiError {
    constructor(body?: unknown);
}

type index_BadRequestError = BadRequestError;
declare const index_BadRequestError: typeof BadRequestError;
type index_EngagementRequest = EngagementRequest;
type index_GetSurfaceRequest = GetSurfaceRequest;
type index_GetSurfaceResponse = GetSurfaceResponse;
type index_GetSurfaceResponseMessagesItem = GetSurfaceResponseMessagesItem;
declare const index_GetSurfaceResponseMessagesItemStatus: typeof GetSurfaceResponseMessagesItemStatus;
type index_InternalServerError = InternalServerError;
declare const index_InternalServerError: typeof InternalServerError;
type index_NotFoundError = NotFoundError;
declare const index_NotFoundError: typeof NotFoundError;
type index_UnauthorizedError = UnauthorizedError;
declare const index_UnauthorizedError: typeof UnauthorizedError;
declare namespace index {
  export {
    index_BadRequestError as BadRequestError,
    index_EngagementRequest as EngagementRequest,
    index_GetSurfaceRequest as GetSurfaceRequest,
    index_GetSurfaceResponse as GetSurfaceResponse,
    index_GetSurfaceResponseMessagesItem as GetSurfaceResponseMessagesItem,
    index_GetSurfaceResponseMessagesItemStatus as GetSurfaceResponseMessagesItemStatus,
    index_InternalServerError as InternalServerError,
    index_NotFoundError as NotFoundError,
    index_UnauthorizedError as UnauthorizedError,
    index$1 as messages,
    index$2 as surfaces,
  };
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare const DoptApiEnvironment: {
    readonly Default: "https://surfaces.dopt.com";
};
declare type DoptApiEnvironment = typeof DoptApiEnvironment.Default;

declare type Supplier<T> = T | Promise<T> | (() => T | Promise<T>);
declare const Supplier: {
    get: <T>(supplier: Supplier<T>) => Promise<T>;
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare namespace Surfaces {
    interface Options {
        environment?: Supplier<DoptApiEnvironment | string>;
        apiKey: Supplier<string>;
    }
    interface RequestOptions {
        timeoutInSeconds?: number;
        maxRetries?: number;
    }
}
declare class Surfaces {
    protected readonly _options: Surfaces.Options;
    constructor(_options: Surfaces.Options);
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     *
     * @example
     *     await doptApi.surfaces.getSurface("sid", {
     *         userIdentifier: "userIdentifier"
     *     })
     *
     * @example
     *     await doptApi.surfaces.getSurface("string", {
     *         userIdentifier: "string",
     *         groupIdentifier: "string"
     *     })
     */
    getSurface(sid: string, request: GetSurfaceRequest, requestOptions?: Surfaces.RequestOptions): Promise<GetSurfaceResponse>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "x-api-key": string;
    }>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare namespace Messages {
    interface Options {
        environment?: Supplier<DoptApiEnvironment | string>;
        apiKey: Supplier<string>;
    }
    interface RequestOptions {
        timeoutInSeconds?: number;
        maxRetries?: number;
    }
}
declare class Messages {
    protected readonly _options: Messages.Options;
    constructor(_options: Messages.Options);
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     *
     * @example
     *     await doptApi.messages.engagement("uid", {
     *         userIdentifier: "userIdentifier",
     *         engagement: "engagement"
     *     })
     *
     * @example
     *     await doptApi.messages.engagement("string", {
     *         userIdentifier: "string",
     *         groupIdentifier: "string",
     *         engagement: "engagement"
     *     })
     */
    engagement(uid: string, request: EngagementRequest, requestOptions?: Messages.RequestOptions): Promise<void>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "x-api-key": string;
    }>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare namespace DoptApiClient {
    interface Options {
        environment?: Supplier<DoptApiEnvironment | string>;
        apiKey: Supplier<string>;
    }
    interface RequestOptions {
        timeoutInSeconds?: number;
        maxRetries?: number;
    }
}
declare class DoptApiClient {
    protected readonly _options: DoptApiClient.Options;
    constructor(_options: DoptApiClient.Options);
    protected _surfaces: Surfaces | undefined;
    get surfaces(): Surfaces;
    protected _messages: Messages | undefined;
    get messages(): Messages;
}

export { index as DoptApi, DoptApiClient, DoptApiEnvironment, DoptApiError, DoptApiTimeoutError };
